package bg.test.ws_security;

import java.util.HashMap;
import java.util.Map;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.interceptor.LoggingInInterceptor;
import org.apache.cxf.interceptor.LoggingOutInterceptor;
import org.apache.cxf.jaxws.JaxWsServerFactoryBean;
import org.apache.cxf.ws.security.wss4j.WSS4JInInterceptor;
import org.apache.ws.security.WSConstants;
import org.apache.ws.security.handler.WSHandlerConstants;

import bg.test.ws_security.server.BgHelloWorld;
import bg.test.ws_security.server.BgHelloWorldImpl;

public class MainServer {

	public static final String endpointAdress = "http://localhost:8085/testServer";

	public MainServer() {
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		System.out.println("Main Server  security");
		System.out.println("Main Server");

		BgHelloWorld implementor = new BgHelloWorldImpl();
		JaxWsServerFactoryBean svrFactory = new JaxWsServerFactoryBean();
		svrFactory.setServiceClass(BgHelloWorld.class);
		svrFactory.setAddress(endpointAdress);
		svrFactory.setServiceBean(implementor);
		svrFactory.getInInterceptors().add(new LoggingInInterceptor());
		svrFactory.getOutInterceptors().add(new LoggingOutInterceptor());

		Map<String, Object> inProps = new HashMap<String, Object>();
		inProps.put(WSHandlerConstants.ACTION, WSHandlerConstants.USERNAME_TOKEN);
		// Password type : plain text
		inProps.put(WSHandlerConstants.PASSWORD_TYPE, WSConstants.PW_TEXT);
		// for hashed password use:
		//properties.put(WSHandlerConstants.PASSWORD_TYPE, WSConstants.PW_DIGEST);
		// Callback used to retrieve password for given user.
		inProps.put(WSHandlerConstants.PW_CALLBACK_CLASS, ServerPasswordCallback.class.getName());
	
		WSS4JInInterceptor wssIn = new WSS4JInInterceptor(inProps);
		svrFactory.getInInterceptors().add(wssIn);

		Server server = svrFactory.create();

		System.out.println("Main Server running " + endpointAdress + "?wsdl");
		System.out.println("Main Server running QNAME: " + server.getEndpoint().getService().getName());

	}

}
